| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
TrcKeySampling Class Reference
Basic

Horizontal sampling (inline and crossline range and steps). More...

`#include <trckeysampling.h>`

## Public Member Functions
| TrcKeySampling ()
| TrcKeySampling (bool settoSI)
| TrcKeySampling (const Pos::GeomID &)
| TrcKeySampling (const TrcKeySampling &)
| ~TrcKeySampling ()
BinID | atIndex (int i0, int i1) const
BinID | atIndex (od_int64 globalidx) const
TrcKey | center () const
BinID | corner (int idx) const
int | crlIdx (Pos::TraceID tid) const
bool | crlOK (int crl) const
StepInterval< int > | crlRange () const
void | expand (int nrlines, int nrtrcs)
void | fillInfoSet (StringPairSet &) const
void | fillJSON (OD::JSON::Object &) const
void | fillPar (IOPar &) const
| Keys as in keystrs.h.
void | get (Interval< int > &linerg, Interval< int > &trcnrrg) const
| steps filled if available
Pos::GeomID | getGeomID () const
bool | getInterSection (const TrcKeySampling &, TrcKeySampling &, bool ignoresteps=false) const
| Returns false if intersection is empty.
TrcKeySampling | getLineChunk (int totalchunks, int chunknr) const
| totalchunks > 0, 0 <= chunknr < totalchunks
BinID | getNearest (const BinID &) const
TrcKey | getNearest (const TrcKey &) const
void | getRandomSet (int nr, TypeSet< TrcKey > &) const
od_int64 | globalIdx (const BinID &) const
od_int64 | globalIdx (const TrcKey &) const
void | growTo (const TrcKeySampling &outertks)
void | include (const BinID &bid)
void | include (const TrcKey &)
void | include (const TrcKeySampling &, bool ignoresteps=false)
void | includeCrl (int crl)
void | includeInl (int inl)
void | includeLine (Pos::LineID)
bool | includes (const BinID &bid) const
bool | includes (const BinID &bid, bool ignoresteps) const
bool | includes (const TrcKey &) const
bool | includes (const TrcKey &, bool ignoresteps) const
bool | includes (const TrcKeySampling &, bool ignoresteps=false) const
void | includeTrc (Pos::TraceID)
void | init (bool settoSI=true)
| Sets to survey values or mUdf(int) (but step 1)
bool | init (const Pos::GeomID &)
void | init (const TrcKey &)
int | inlIdx (Pos::LineID lid) const
bool | inlOK (int inl) const
StepInterval< int > | inlRange () const
bool | is2D () const
bool | isDefined () const
bool | isEmpty () const
bool | isSynthetic () const
bool | isUdf () const
void | limitTo (const TrcKeySampling &, bool ignoresteps=false)
void | limitToWithUdf (const TrcKeySampling &)
float | lineDistance () const
Pos::LineID | lineID (int) const
int | lineIdx (Pos::LineID) const
int | lineIdxFromGlobal (od_int64) const
bool | lineOK (Pos::LineID) const
bool | lineOK (Pos::LineID, bool ignoresteps) const
StepInterval< int > | lineRange () const
void | neighbors (const TrcKey &, TypeSet< TrcKey > &) const
void | neighbors (od_int64 globalidx, TypeSet< od_int64 > &) const
void | normalise ()
void | normalize ()
| Makes sure start_<stop_ and steps are non-zero.
int | nrCrl () const
int | nrInl () const
int | nrLines () const
int | nrTrcs () const
bool | operator!= (const TrcKeySampling &) const
TrcKeySampling & | operator= (const TrcKeySampling &)
bool | operator== (const TrcKeySampling &) const
bool | overlaps (const TrcKeySampling &, bool ignoresteps=false) const
TrcKeySampling & | set (const Interval< int > &linerg, const Interval< int > &trcnrrg)
| steps copied if available
TrcKeySampling & | set (const Pos::GeomID &, const Interval< int > &trcnrrg)
TrcKeySampling & | set (const TrcKey &)
void | set2DDef ()
| Sets ranges to 0-maxint.
void | setCrlRange (const Interval< int > &rg)
void | setGeomID (const Pos::GeomID &)
void | setInlRange (const Interval< int > &rg)
void | setLineRange (const Interval< int > &)
void | setTrcRange (const Interval< int > &)
void | shrinkTo (const TrcKeySampling &innertks)
void | snapToSurvey ()
Coord | toCoord (const BinID &) const
void | toString (BufferString &) const
| Nice text for info.
od_int64 | totalNr () const
TrcKey | toTrcKey (const Coord &, float *distance=nullptr) const
Pos::TraceID | traceID (int) const
float | trcDistance () const
int | trcIdx (Pos::TraceID) const
int | trcIdxFromGlobal (od_int64) const
TrcKey | trcKeyAt (int i0, int i1) const
TrcKey | trcKeyAt (od_int64 globalidx) const
bool | trcOK (Pos::TraceID) const
bool | trcOK (Pos::TraceID, bool ignoresteps) const
StepInterval< int > | trcRange () const
bool | useJSON (const OD::JSON::Object &)
bool | usePar (const IOPar &)
| Keys as in keystrs.h.

## Static Public Member Functions
static TrcKeySampling | getSynth (const Interval< int > *trcrg=nullptr)
static void | removeInfo (IOPar &)

## Public Attributes
BinID & | start
BinID | start_
BinID & | step
BinID | step_
BinID & | stop
BinID | stop_
OD::GeomSystem | survid_

## Detailed Description

Horizontal sampling (inline and crossline range and steps).

<>

## Constructor & Destructor Documentation

## ◆ TrcKeySampling() [1/4]

TrcKeySampling::TrcKeySampling | ( |  | ) |

## ◆ TrcKeySampling() [2/4]

TrcKeySampling::TrcKeySampling | ( | const TrcKeySampling & |  | ) |

## ◆ TrcKeySampling() [3/4]

TrcKeySampling::TrcKeySampling | ( | const Pos::GeomID & |  | ) |

## ◆ TrcKeySampling() [4/4]

TrcKeySampling::TrcKeySampling | ( | bool | settoSI | ) |
| explicit

## ◆ ~TrcKeySampling()

TrcKeySampling::~TrcKeySampling | ( |  | ) |

## Member Function Documentation

## ◆ atIndex() [1/2]

BinID TrcKeySampling::atIndex | ( | int | i0,
|  | int | i1 ) const

## ◆ atIndex() [2/2]

BinID TrcKeySampling::atIndex | ( | od_int64 | globalidx | ) | const

## ◆ center()

TrcKey TrcKeySampling::center | ( |  | ) | const

## ◆ corner()

BinID TrcKeySampling::corner | ( | int | idx | ) | const

## ◆ crlIdx()

int TrcKeySampling::crlIdx | ( | Pos::TraceID | tid | ) | const
| inline

## ◆ crlOK()

bool TrcKeySampling::crlOK | ( | int | crl | ) | const
| inline

## ◆ crlRange()

StepInterval< int > TrcKeySampling::crlRange | ( |  | ) | const
| inline

## ◆ expand()

void TrcKeySampling::expand | ( | int | nrlines,
|  | int | nrtrcs )

## ◆ fillInfoSet()

void TrcKeySampling::fillInfoSet | ( | StringPairSet & |  | ) | const

## ◆ fillJSON()

void TrcKeySampling::fillJSON | ( | OD::JSON::Object & |  | ) | const

## ◆ fillPar()

void TrcKeySampling::fillPar | ( | IOPar & |  | ) | const

Keys as in keystrs.h.

## ◆ get()

void TrcKeySampling::get | ( | Interval< int > & | linerg,
|  | Interval< int > & | trcnrrg ) const

steps filled if available

## ◆ getGeomID()

Pos::GeomID TrcKeySampling::getGeomID | ( |  | ) | const

## ◆ getInterSection()

bool TrcKeySampling::getInterSection | ( | const TrcKeySampling & | ,
|  | TrcKeySampling & | ,
|  | bool | ignoresteps = false ) const

Returns false if intersection is empty.

## ◆ getLineChunk()

TrcKeySampling TrcKeySampling::getLineChunk | ( | int | totalchunks,
|  | int | chunknr ) const

totalchunks > 0, 0 <= chunknr < totalchunks

## ◆ getNearest() [1/2]

BinID TrcKeySampling::getNearest | ( | const BinID & |  | ) | const

## ◆ getNearest() [2/2]

TrcKey TrcKeySampling::getNearest | ( | const TrcKey & |  | ) | const

step_-snap and outside -> edge. Assumes inldist == crldist

## ◆ getRandomSet()

void TrcKeySampling::getRandomSet | ( | int | nr,
|  | TypeSet< TrcKey > & | ) const

## ◆ getSynth()

static TrcKeySampling TrcKeySampling::getSynth | ( | const Interval< int > * | trcrg = nullptr | ) |
| static

## ◆ globalIdx() [1/2]

od_int64 TrcKeySampling::globalIdx | ( | const BinID & |  | ) | const

## ◆ globalIdx() [2/2]

od_int64 TrcKeySampling::globalIdx | ( | const TrcKey & |  | ) | const

## ◆ growTo()

void TrcKeySampling::growTo | ( | const TrcKeySampling & | outertks | ) |

## ◆ include() [1/3]

void TrcKeySampling::include | ( | const BinID & | bid | ) |
| inline

## ◆ include() [2/3]

void TrcKeySampling::include | ( | const TrcKey & |  | ) |

## ◆ include() [3/3]

void TrcKeySampling::include | ( | const TrcKeySampling & | ,
|  | bool | ignoresteps = false )

## ◆ includeCrl()

void TrcKeySampling::includeCrl | ( | int | crl | ) |
| inline

## ◆ includeInl()

void TrcKeySampling::includeInl | ( | int | inl | ) |
| inline

## ◆ includeLine()

void TrcKeySampling::includeLine | ( | Pos::LineID |  | ) |

## ◆ includes() [1/5]

bool TrcKeySampling::includes | ( | const BinID & | bid | ) | const
| inline

## ◆ includes() [2/5]

bool TrcKeySampling::includes | ( | const BinID & | bid,
|  | bool | ignoresteps ) const
| inline

## ◆ includes() [3/5]

bool TrcKeySampling::includes | ( | const TrcKey & |  | ) | const

## ◆ includes() [4/5]

bool TrcKeySampling::includes | ( | const TrcKey & | ,
|  | bool | ignoresteps ) const

## ◆ includes() [5/5]

bool TrcKeySampling::includes | ( | const TrcKeySampling & | ,
|  | bool | ignoresteps = false ) const

## ◆ includeTrc()

void TrcKeySampling::includeTrc | ( | Pos::TraceID |  | ) |

## ◆ init() [1/3]

void TrcKeySampling::init | ( | bool | settoSI = true | ) |

Sets to survey values or mUdf(int) (but step 1)

## ◆ init() [2/3]

bool TrcKeySampling::init | ( | const Pos::GeomID & |  | ) |

## ◆ init() [3/3]

void TrcKeySampling::init | ( | const TrcKey & |  | ) |

## ◆ inlIdx()

int TrcKeySampling::inlIdx | ( | Pos::LineID | lid | ) | const
| inline

## ◆ inlOK()

bool TrcKeySampling::inlOK | ( | int | inl | ) | const
| inline

## ◆ inlRange()

StepInterval< int > TrcKeySampling::inlRange | ( |  | ) | const
| inline

## ◆ is2D()

bool TrcKeySampling::is2D | ( |  | ) | const
| inline

## ◆ isDefined()

bool TrcKeySampling::isDefined | ( |  | ) | const

## ◆ isEmpty()

bool TrcKeySampling::isEmpty | ( |  | ) | const

## ◆ isSynthetic()

bool TrcKeySampling::isSynthetic | ( |  | ) | const
| inline

## ◆ isUdf()

bool TrcKeySampling::isUdf | ( |  | ) | const

## ◆ limitTo()

void TrcKeySampling::limitTo | ( | const TrcKeySampling & | ,
|  | bool | ignoresteps = false )

## ◆ limitToWithUdf()

void TrcKeySampling::limitToWithUdf | ( | const TrcKeySampling & |  | ) |

handles undef values +returns reference HS nearest limit if HS's do not intersect

## ◆ lineDistance()

float TrcKeySampling::lineDistance | ( |  | ) | const

real world distance between 2 lines incremented by one times the step_

## ◆ lineID()

Pos::LineID TrcKeySampling::lineID | ( | int | lidx | ) | const
| inline

## ◆ lineIdx()

int TrcKeySampling::lineIdx | ( | Pos::LineID | line | ) | const
| inline

## ◆ lineIdxFromGlobal()

int TrcKeySampling::lineIdxFromGlobal | ( | od_int64 |  | ) | const

## ◆ lineOK() [1/2]

bool TrcKeySampling::lineOK | ( | Pos::LineID |  | ) | const

## ◆ lineOK() [2/2]

bool TrcKeySampling::lineOK | ( | Pos::LineID | ,
|  | bool | ignoresteps ) const

## ◆ lineRange()

StepInterval< int > TrcKeySampling::lineRange | ( |  | ) | const

## ◆ neighbors() [1/2]

void TrcKeySampling::neighbors | ( | const TrcKey & | ,
|  | TypeSet< TrcKey > & | ) const

## ◆ neighbors() [2/2]

void TrcKeySampling::neighbors | ( | od_int64 | globalidx,
|  | TypeSet< od_int64 > & | ) const

## ◆ normalise()

void TrcKeySampling::normalise | ( |  | ) |

## ◆ normalize()

void TrcKeySampling::normalize | ( |  | ) |

Makes sure start_<stop_ and steps are non-zero.

## ◆ nrCrl()

int TrcKeySampling::nrCrl | ( |  | ) | const
| inline

## ◆ nrInl()

int TrcKeySampling::nrInl | ( |  | ) | const
| inline

## ◆ nrLines()

int TrcKeySampling::nrLines | ( |  | ) | const

## ◆ nrTrcs()

int TrcKeySampling::nrTrcs | ( |  | ) | const

## ◆ operator!=()

bool TrcKeySampling::operator!= | ( | const TrcKeySampling & |  | ) | const

## ◆ operator=()

TrcKeySampling & TrcKeySampling::operator= | ( | const TrcKeySampling & |  | ) |

## ◆ operator==()

bool TrcKeySampling::operator== | ( | const TrcKeySampling & |  | ) | const

## ◆ overlaps()

bool TrcKeySampling::overlaps | ( | const TrcKeySampling & | ,
|  | bool | ignoresteps = false ) const

## ◆ removeInfo()

static void TrcKeySampling::removeInfo | ( | IOPar & |  | ) |
| static

## ◆ set() [1/3]

TrcKeySampling & TrcKeySampling::set | ( | const Interval< int > & | linerg,
|  | const Interval< int > & | trcnrrg )

steps copied if available

## ◆ set() [2/3]

TrcKeySampling & TrcKeySampling::set | ( | const Pos::GeomID & | ,
|  | const Interval< int > & | trcnrrg )

## ◆ set() [3/3]

TrcKeySampling & TrcKeySampling::set | ( | const TrcKey & |  | ) |

## ◆ set2DDef()

void TrcKeySampling::set2DDef | ( |  | ) |

Sets ranges to 0-maxint.

## ◆ setCrlRange()

void TrcKeySampling::setCrlRange | ( | const Interval< int > & | rg | ) |
| inline

## ◆ setGeomID()

void TrcKeySampling::setGeomID | ( | const Pos::GeomID & |  | ) |

## ◆ setInlRange()

void TrcKeySampling::setInlRange | ( | const Interval< int > & | rg | ) |
| inline

## ◆ setLineRange()

void TrcKeySampling::setLineRange | ( | const Interval< int > & |  | ) |

## ◆ setTrcRange()

void TrcKeySampling::setTrcRange | ( | const Interval< int > & |  | ) |

## ◆ shrinkTo()

void TrcKeySampling::shrinkTo | ( | const TrcKeySampling & | innertks | ) |

## ◆ snapToSurvey()

void TrcKeySampling::snapToSurvey | ( |  | ) |

Checks if it is on valid bids. If not, it will expand until it is

## ◆ toCoord()

Coord TrcKeySampling::toCoord | ( | const BinID & |  | ) | const

## ◆ toString()

void TrcKeySampling::toString | ( | BufferString & |  | ) | const

Nice text for info.

## ◆ totalNr()

od_int64 TrcKeySampling::totalNr | ( |  | ) | const

## ◆ toTrcKey()

TrcKey TrcKeySampling::toTrcKey | ( | const Coord & | ,
|  | float * | distance = nullptr ) const

## ◆ traceID()

Pos::TraceID TrcKeySampling::traceID | ( | int | tidx | ) | const
| inline

## ◆ trcDistance()

float TrcKeySampling::trcDistance | ( |  | ) | const

real world distance between 2 traces incremented by one times the step_

## ◆ trcIdx()

int TrcKeySampling::trcIdx | ( | Pos::TraceID | trcid | ) | const
| inline

## ◆ trcIdxFromGlobal()

int TrcKeySampling::trcIdxFromGlobal | ( | od_int64 |  | ) | const

## ◆ trcKeyAt() [1/2]

TrcKey TrcKeySampling::trcKeyAt | ( | int | i0,
|  | int | i1 ) const

## ◆ trcKeyAt() [2/2]

TrcKey TrcKeySampling::trcKeyAt | ( | od_int64 | globalidx | ) | const

## ◆ trcOK() [1/2]

bool TrcKeySampling::trcOK | ( | Pos::TraceID |  | ) | const

## ◆ trcOK() [2/2]

bool TrcKeySampling::trcOK | ( | Pos::TraceID | ,
|  | bool | ignoresteps ) const

## ◆ trcRange()

StepInterval< int > TrcKeySampling::trcRange | ( |  | ) | const

## ◆ useJSON()

bool TrcKeySampling::useJSON | ( | const OD::JSON::Object & |  | ) |

## ◆ usePar()

bool TrcKeySampling::usePar | ( | const IOPar & |  | ) |

Keys as in keystrs.h.

## Member Data Documentation

## ◆ start

BinID& TrcKeySampling::start

## ◆ start_

BinID TrcKeySampling::start_

## ◆ step

BinID& TrcKeySampling::step

## ◆ step_

BinID TrcKeySampling::step_

## ◆ stop

BinID& TrcKeySampling::stop

## ◆ stop_

BinID TrcKeySampling::stop_

## ◆ survid_

OD::GeomSystem TrcKeySampling::survid_

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025